/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { ScrollInfo } from "./ScrollInfo";
import { toNullable, Number_$type, markType } from "igniteui-webcomponents-core";
import { nullableIsNull } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var ExtendedRangeScrollInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ExtendedRangeScrollInfo, _super);
    function ExtendedRangeScrollInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._av = 0;
        _this._aw = toNullable(Number_$type, null);
        return _this;
    }
    ExtendedRangeScrollInfo.prototype._aq = function (a) {
        if (!this._at) {
            a = this._au(a);
        }
        _super.prototype._aq.call(this, a);
    };
    Object.defineProperty(ExtendedRangeScrollInfo.prototype, "_at", {
        get: function () {
            return this._av > 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ExtendedRangeScrollInfo.prototype, "_ax", {
        get: function () {
            return this._aw;
        },
        enumerable: false,
        configurable: true
    });
    ExtendedRangeScrollInfo.prototype._ay = function () {
        this._av--;
        if (this._av == 0) {
            this._aw = toNullable(Number_$type, null);
            this._ak("IsRangeChangeSuspended");
            this._au(this._ac);
        }
    };
    ExtendedRangeScrollInfo.prototype._az = function (a) {
        this._ac = a;
    };
    ExtendedRangeScrollInfo.prototype._a0 = function (a) {
        if (a === void 0) {
            a = toNullable(Number_$type, null);
        }
        this._av++;
        if (this._av == 1) {
            this._aw = toNullable(Number_$type, !nullableIsNull(a) ? a.value : this._ac);
            this._ak("IsRangeChangeSuspended");
        }
    };
    ExtendedRangeScrollInfo.$t = markType(ExtendedRangeScrollInfo, 'ExtendedRangeScrollInfo', ScrollInfo.$);
    return ExtendedRangeScrollInfo;
}(ScrollInfo));
export { ExtendedRangeScrollInfo };
